//********************************************************************************************************
// Programma RGB_BT 
// pilota i led RGB delle barre led di illuminazione dei led di abitacolo della CiCCi
// riceve i comandi dal BT su HW Seriale 1 e comanda in PWM i colori delle barre (anodo comune)
// comanda l'alimentazione (anodo) in pwm su un FET per modulare l'intensità luminosa diminuemndo il VCC 
// ai driver dei led RGB. memorizza in EEPROM il colore settato per ultimo , memorizza in EEPROM il valore
// di tensione sul FET (alimentazione dell'anodo).
// versione 1 - 26/12/2021
//********************************************************************************************************

#include <EEPROM.h>

int bluepin =9; // select the pin for the  blue LED
int greenpin = 10;// select the pin for the green LED
int redpin = 11; //select the pin for the red LED
int powerpin = 3; //select the pin for the power to LED's

char valore;
char prevcol = 'R';

int valR = 128;
int valG = 128;
int valB = 128;
int valP = 128;

void setup() {
  pinMode(redpin, OUTPUT);
  pinMode(bluepin, OUTPUT);
  pinMode(greenpin, OUTPUT);
  pinMode(powerpin, OUTPUT);
  Serial.begin(9600);
  
  prevcol = EEPROM.read(0);
  valP = EEPROM.read(1);
//  Serial.println(prevcol);
     switch(prevcol)
        {
           case 'R': 
                 valR = 128;
                 valG = 0;
                 valB = 0;
           break;
           case 'G':
                 valR = 0;
                 valG = 128;
                 valB = 0; 
           break;
           case 'B': 
                 valR = 0;
                 valG = 0;
                 valB = 128;
           break;
           case 'W': 
                 valR = 255;
                 valG = 255;
                 valB = 255;
           break;
           case 'M': 
                 valR = 204;
                 valG = 0;
                 valB = 204;
           break;
           case 'O': 
                 valR = 255;
                 valG = 128;
                 valB = 0;
           break;
        }
     illumina();
}

void loop() 
{ 
   if(Serial.available())
      {
        valore = Serial.read();
 //       Serial.println(valore);
        switch(valore)
        {
           case 'R': 
                 valR = 255;
                 valG = 0;
                 valB = 0;
                 prevcol = 'R';
                 EEPROM.update(0, prevcol);
           break;
           case 'G':
                 valR = 0;
                 valG = 255;
                 valB = 0; 
                 prevcol = 'G';
                 EEPROM.update(0, prevcol);
           break;
           case 'B': 
                 valR = 0;
                 valG = 0;
                 valB = 255;
                 prevcol = 'B'; 
                 EEPROM.update(0, prevcol);
           break;
           case 'W': 
                 valR = 255;
                 valG = 255;
                 valB = 255;
                 prevcol = 'W'; 
                 EEPROM.update(0, prevcol);
           break;
           case 'O': 
                 valR = 255;
                 valG = 128;
                 valB = 0;
                 prevcol = 'O'; 
                 EEPROM.update(0, prevcol);
           break;
           case 'M': 
                 valR = 204;
                 valG = 0;
                 valB = 204;
                 prevcol = 'M'; 
                 EEPROM.update(0, prevcol);
           break;
           case 'F': 
                 valR = 0;
                 valG = 0;
                 valB = 0;
                 prevcol = 'M'; 
                 EEPROM.update(0, prevcol);
           break;
           case '+': 
              piupower();  
              EEPROM.update(1, valP);   
 //             aumenta();
           break;
           case '-':
              menopower();  
              EEPROM.update(1, valP);    
 //             diminuisce();
           break;
        }
        illumina();
       }
       else
       {
       }
       delay(100);
}
//===============================================
void illumina()
{
/*   
   analogWrite(redpin,255 - valR);      // red
   analogWrite(greenpin,255 - valG);    // green
   analogWrite(bluepin,255 - valB);     // blu
*/
   analogWrite(redpin,   valR);     // red
   analogWrite(greenpin, valG);     // green
   analogWrite(bluepin,  valB);     // blu
   analogWrite(powerpin, valP);     // power (0-12vdc)   
/*       
   Serial.print(valR);
   Serial.print(';');
   Serial.print(valG);
   Serial.print(';');
   Serial.println(valB);
 */
}

//===============================================
void piupower()
{
    valP -= 25;
    if(valP < 0) valP = 0;
}
//===============================================
void menopower()
{
    valP += 25;
    if(valP > 255) valP = 255;
}
/*
//===============================================
void aumenta()   // diminuisce()
{
        switch(prevcol)
        {
           case 'R': 
                 valR += 25;
                 if(valR > 255) valR = 255;
                 valG = 0;
                 valB = 0;
           break;
           case 'G':
                 valR = 0;
                 valG += 25;
                 if(valG > 255) valG = 255;
                 valB = 0; 
           break;
           case 'B': 
                 valR = 0;
                 valG = 0;
                 valB += 25;
                 if(valB > 255) valB = 255;
           break;
           case 'M': 
                 valR = 254;
                 valG = 0;
                 valB = 254;
           break;
           case 'O': 
                 valR = 255;
                 valG = 128;
                 valB = 0;
           break;
         }
}
//===============================================
void diminuisce() //aumenta ()
{
        switch(prevcol)
        {
           case 'R': 
                 valR -= 25;
                 if(valR < 0) valR = 0;
                 valG = 0;
                 valB = 0;
           break;
           case 'G':
                 valR = 0;
                 valG -= 25;
                 if(valG < 0) valG = 0;
                 valB = 0; 
           break;
           case 'B': 
                 valR = 0;
                 valG = 0;
                 valB -= 25;
                 if(valB < 0) valB = 0;
           break;
           case 'M': 
                 valR = 104;
                 valG = 0;
                 valB = 104;
           break;
           case 'O': 
                 valR = 128;
                 valG = 64;
                 valB = 0;
           break;
         }
}
*/
